//+------------------------------------------------------------------+
//|                                            Linear Regression.mq4 |
//|                Copyright  2006, tageiger, aka fxid10t@yahoo.com |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, tageiger, aka fxid10t@yahoo.com"
#property link      "http://www.metaquotes.net"
#property indicator_chart_window

//extern int EndDayHour=23;
extern int period=0;
/*default 0 means the channel will use the open time from "x" bars back on which ever time period 
the indicator is attached to.  one can change to 1,5,15,30,60...etc to "lock" the start time to a specific 
period, and then view the "locked" channels on a different time period...*/
extern int line.width=1;
//extern int LR.length=24;   // bars back regression begins
//extern color  LR.c=Orange;
extern double std.channel.1=0.618;        // 1st channel
extern color  c.1=Gray;
extern double std.channel.2=1.618;        // 2nd channel
extern color  c.2=Gray;
extern double std.channel.3=2.618;        // 3nd channel
//extern color  c.3=Gray; iLowest MODE_CLOSE
int d;
int days=0;
static int c2=0,c3=0;

/*
int hbar = iHighest(Symbol(),PERIOD_M15,MODE_HIGH,4,1); // ?????? ??? ???? ???? ??? 
int lbar = iLowest(Symbol(),PERIOD_M15,MODE_LOW,4,1); // ?????? ??? ???? ??? ?? 
double sl_sell = iHigh(Symbol(),PERIOD_M15,hbar); // ?????? ???? ????? ?????? 
double sl_buy = iLow(Symbol(),PERIOD_M15,lbar);  // ?????? ???? ???? ??????  


*/
int init()
{
   

   return(0);

}

int deinit()
{
   /*
   ObjectDelete(period+"m "+LR.length+" TL"); 
   ObjectDelete(period+"m "+LR.length+" +"+std.channel.1+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.1+"d");
   ObjectDelete(period+"m "+LR.length+" +"+std.channel.2+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.2+"d");
   ObjectDelete(period+"m "+LR.length+" +"+std.channel.3+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.3+"d");
   */
   return(0);
}


int start()

{

      static datetime prevtime=0; 
      if(prevtime == Time[0])
      {
         return(0);
      }
      prevtime = Time[0];
      
      linear(24, 24,Yellow , Red, 0);
      //linear(24, 48,Yellow , Blue, 0);
      //linear(24, 72,Yellow , Orange, 0);
      
   return(0);
}


int linear(int EndDayHour, int LR.length, color LR.c, color c.3, int style)
{
//refresh chart
/*
ObjectDelete(period+"m "+LR.length+" TL");
ObjectDelete(period+"m "+LR.length+" +"+std.channel.1+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.1+"d");
ObjectDelete(period+"m "+LR.length+" +"+std.channel.2+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.2+"d");
ObjectDelete(period+"m "+LR.length+" +"+std.channel.3+"d"); ObjectDelete(period+"m "+LR.length+" -"+std.channel.3+"d");
*/
//linear regression calculation
int start.bar=LR.length, end.bar=0;
   int n=start.bar-end.bar+1;
//---- calculate price values
   double value=iClose(Symbol(),period,end.bar);
   double a,b,c;
   double sumy=value;
   double sumx=0.0;
   double sumxy=0.0;
   double sumx2=0.0;
   for(int i=1; i<n; i++)
     {
      value=iClose(Symbol(),period,end.bar+i);
      sumy+=value;
      sumxy+=value*i;
      sumx+=i;
      sumx2+=i*i;
     }
   c=sumx2*n-sumx*sumx;
   if(c==0.0) return;
   b=(sumxy*n-sumx*sumy)/c;
   a=(sumy-sumx*b)/n;
   double LR.price.2=a;
   double LR.price.1=a+b*n;
 
//---- maximal deviation calculation (not used)
   double max.dev=0;
   double deviation=0;
   double dvalue=a;
   for(i=0; i<n; i++)
   {
      value=iClose(Symbol(),period,end.bar+i);
      dvalue+=b;
      deviation=MathAbs(value-dvalue);
      if(max.dev<=deviation) max.dev=deviation;
   }
   //Linear regression trendline

    d=EndDayHour;
    //Comment("   i = ",c2,"      ","      ",TimeHour(Time[0]));
    
    if (iClose(Symbol(),period,0) > ObjectGetValueByShift(LR.length+"00",0))
    {Comment(" Up ");}
    else
    {Comment(" Down ");}
               
               
    if (TimeHour(Time[0]) == 0)
    {
      if(EndDayHour<25)
      {
         
         if (TimeHour(Time[1]) == 23) {d=EndDayHour - 1;}
         if (TimeHour(Time[1]) == 22) {d=EndDayHour - 2;}
         if (TimeHour(Time[1]) == 21) {d=EndDayHour - 3;}
         if (TimeHour(Time[1]) == 20) {d=EndDayHour - 4;}
         if (TimeHour(Time[1]) == 19) {d=EndDayHour - 5;}
         if (TimeHour(Time[1]) == 18) {d=EndDayHour - 6;}
         if (TimeHour(Time[1]) == 17) {d=EndDayHour - 7;}
         if (TimeHour(Time[1]) == 16) {d=EndDayHour - 8;}
         if (TimeHour(Time[1]) == 15) {d=EndDayHour - 9;}
         if (TimeHour(Time[1]) == 14) {d=EndDayHour - 10;}
         if (TimeHour(Time[1]) == 13) {d=EndDayHour - 11;}
         if (TimeHour(Time[1]) == 12) {d=EndDayHour - 12;}
         if (TimeHour(Time[1]) == 11) {d=EndDayHour - 13;}
         if (TimeHour(Time[1]) == 10) {d=EndDayHour - 14;}
         if (TimeHour(Time[1]) == 9) {d=EndDayHour - 15;}
         if (TimeHour(Time[1]) == 8) {d=EndDayHour - 16;}
         if (TimeHour(Time[1]) == 7) {d=EndDayHour - 17;}
         if (TimeHour(Time[1]) == 6) {d=EndDayHour - 18;}
         if (TimeHour(Time[1]) == 5) {d=EndDayHour - 19;}
         if (TimeHour(Time[1]) == 4) {d=EndDayHour - 20;}
         if (TimeHour(Time[1]) == 3) {d=EndDayHour - 21;}
         if (TimeHour(Time[1]) == 2) {d=EndDayHour - 22;}
         if (TimeHour(Time[1]) == 1) {d=EndDayHour - 23;}
         
      }
      for(int i2=1;i2<80;i2++)
      {
         if(TimeHour(Time[i2])==23)
         {  
               datetime aaa=iTime(Symbol(),period,start.bar);
               ObjectDelete(LR.length+"00");
               ObjectDelete(LR.length+"+01");
               ObjectDelete(LR.length+"-01");

               ObjectCreate(LR.length+"00",OBJ_TREND,0,aaa,LR.price.1,Time[end.bar],LR.price.2);
               ObjectSet(LR.length+"00",OBJPROP_COLOR,LR.c);
               ObjectSet(LR.length+"00",OBJPROP_WIDTH,line.width);
               ObjectSet(LR.length+"00",OBJPROP_RAY,true); 
               ObjectSet(LR.length+"00",OBJPROP_STYLE,style);    
               //...standard deviation...
               
               
               
               double x=0,x1=0,x.sum=0,x.avg=0,x.sum.squared=0,highest=0;
               for(i=0; i<23; i++)
               {
               double curHigh0=MathAbs(iClose(Symbol(),period,i+2)-ObjectGetValueByShift(LR.length+"00",i+2));
               double curHigh1=MathAbs(iClose(Symbol(),period,i+1)-ObjectGetValueByShift(LR.length+"00",i+1));
               double curHigh2=MathAbs(iClose(Symbol(),period,i)-ObjectGetValueByShift(LR.length+"00",i));
               double curHigh3=MathAbs(iClose(Symbol(),period,i-1)-ObjectGetValueByShift(LR.length+"00",i-1));
               double curHigh4=MathAbs(iClose(Symbol(),period,i-2)-ObjectGetValueByShift(LR.length+"00",i-2));

               if(curHigh2>=curHigh0 && curHigh2>=curHigh1 && curHigh2>=curHigh3 && curHigh2>=curHigh4)
               {  
                  //if(highest<curHigh2)
                  //{
                     x1=i;
                     x=curHigh2;
                     //Comment(x,"    ",x1);
                  //}
               }
               }
               
               /*
               int z=0;
               double x=0,x1=0,x.sum=0,x.avg=0,x.sum.squared=0,std.dev=0;
               for(i=0; i<start.bar; i++)
               {
                  x=MathAbs(iClose(Symbol(),period,i)-ObjectGetValueByShift(LR.length+"00",i));
                  x1=MathAbs(iClose(Symbol(),period,z)-ObjectGetValueByShift(LR.length+"00",z));
                  if (x>=x1){z=i;}
                  Comment("  X=  ",x,"  I=  ",i,"  start.bar=  ",start.bar,"  X=  ",x);
                  //x=x*2.618;
                  
                  x.sum+=x;
                  if(i>0)
                  {
                     x.avg=(x.avg+x)/i;
                     x.sum.squared+=(x-x.avg)*(x-x.avg);
                     std.dev=MathSqrt(x.sum.squared/(start.bar-1));
                  }
                  
               }
               */
               //Comment(x);
               
            //Print("LR.price.1 ",LR.price.1,"  LR.Price.2 ",LR.price.2," std.dev ",std.dev);
            //...standard deviation channels...
            
            ObjectCreate(LR.length+"+01",OBJ_TREND,0,aaa,LR.price.1+x,
                                             Time[end.bar],LR.price.2+x);
            ObjectSet(LR.length+"+01" ,OBJPROP_COLOR,c.3);
            ObjectSet(LR.length+"+01" ,OBJPROP_WIDTH,line.width);
            ObjectSet(LR.length+"+01" ,OBJPROP_RAY,true);
            ObjectSet(LR.length+"+01",OBJPROP_STYLE,style);
   
            ObjectCreate(LR.length+"-01",OBJ_TREND,0,aaa,LR.price.1-x,
                                             Time[end.bar],LR.price.2-x);
            ObjectSet(LR.length+"-01",OBJPROP_COLOR,c.3);
            ObjectSet(LR.length+"-01",OBJPROP_WIDTH,line.width);
            ObjectSet(LR.length+"-01",OBJPROP_RAY,true);
            ObjectSet(LR.length+"-01",OBJPROP_STYLE,style);
 
        }
     
     }
   }
return(0);

}


